local frame_size_default = {140, 14}
local events = {
--[[ TO DELETE
	{
		"Test Event 1",
		19, 10, 2015,
		{
			{0, 0, 0, 1},
			{0.3, 0, 0, 1},
			{0.6, 0, 0, 1},
			{1, 0, 0, 1}
		},
		nil,
		11
	},
	{
		"Test Event 2",
		19, 10, 2015,
		{
			{0, 0, 0, 1},
			{0, 0.3, 0, 1},
			{0, 0.6, 0, 1},
			{0, 1, 0, 1}
		},
		nil,
		12 - 1/6
	},
	{
		"Test Event 3",
		19, 10, 2015,
		{
			{0, 0, 0, 1},
			{0, 0, 0.3, 1},
			{0, 0, 0.6, 1},
			{0, 0, 1, 1},
		},
		nil,
		13 + 1/6
	},
	{
		"Test Event 1",
		19, 10, 2015,
		{
			{0, 0, 0, 1},
			{0.3, 0, 0, 1},
			{0.6, 0, 0, 1},
			{1, 0, 0, 1}
		},
		1,
		12
	},
	{
		"Test Event 2",
		19, 10, 2015,
		{
			{0, 0, 0, 1},
			{0, 0.3, 0, 1},
			{0, 0.6, 0, 1},
			{0, 1, 0, 1}
		},
		1,
		13 - 1/6
	},
	{
		"Test Event 3",
		20, 10, 2015,
		{
			{0, 0, 0, 1},
			{0, 0, 0.3, 1},
			{0, 0, 0.6, 1},
			{0, 0, 1, 1},
		},
		1,
		-10 + 1/6
	},
	
]]--
	{
		"Hallow's End",
		18, 10, 2015,
		{
			{0, 0.2, 1, 1},
			{0, 1, 0.2, 1},
			{1, 0, 0, 1},
			{0, 0, 0, 1}
		}
	},
	{
		"WoW's 11th Anniversary",
		16, 11, 2015,
		{
			{ 0, 0.2, 1, 0.5 },
			{ 0.5, 0, 1, 1 },
			{ 1, 0.5, 0, 1 },
			{0, 0.4, 1, 1}
		}
	},
	{
		"Pilgrim's Bounty",
		23, 11, 2015,
		{
			{ 0, 0.2, 1, 0.5 },
			{ 0, 1, 0.2, 1 },
			{ 1, 0, 0, 1 },
			{ 1, 0.8, 0, 1 }
		}
	},
	{
		"Winter Veil",
		16, 12, 2015,
		{
			{ 0, 0.2, 1, 0.5 },
			{ 0.5, 0.6, 1, 1 },
			{ 0.8, 0.9, 1, 1 },
			{ 1, 1, 1, 1 }
		}
	},
	{
		"Lunar Festival",
		1, 2, 2016,
		{
			{ 0, 0.2, 1, 0.5 },
			{ 1, 0, 0, 0.5 },
			{ 0.8, 0, 1, 1 },
			{ 1, 1, 1, 1 }
		}
	},
	{
		"Love is in the Air",
		15, 2, 2016,
		{
			{ 0, 0.2, 1, 0.5 },
			{ 1, 1, 1, 0.5 },
			{ 1, 0.4, 1, 1 },
			{ 1, 0.2, 0.8, 1 }
		}
	},
	---------------------------------------------------
	{
		"Hallow's End",
		1, 11, 2015,
		{
			{0, 0, 0, 1},
			{1, 0, 0, 1},
			{0, 1, 0.2, 1},
			{0, 0.2, 1, 1}
		},
		1,
		1
	},
	{
		"WoW's 11th Anniversary",
		30, 11, 2015,
		{
			{ 0, 0.2, 1, 0.5 },
			{ 0.5, 0, 1, 1 },
			{ 1, 0.5, 0, 1 }
		},
		1,
	},
	{
		"Pilgrim's Bounty",
		30, 11, 2015,
		{
			{ 0, 1, 0.2, 0.5 },
			{ 1, 0, 0, 1 },
			{ 1, 0.8, 0, 1 }
		},
		1,
		-1
	},
	{
		"Winter Veil",
		2 - 4/24, 1, 2015,
		{
			{ 0.5, 0.6, 1, 0.5 },
			{ 0.8, 0.9, 1, 1 },
			{ 1, 1, 1, 1 }
		},
		1,
		-4
	},
	{
		"Lunar Festival",
		15, 2, 2016,
		{
			{ 1, 0, 0, 0.5 },
			{ 0.8, 0, 1, 1 },
			{ 1, 1, 1, 1 }
		},
		1,
		0
	},
	{
		"Love is in the Air",
		29, 2, 2016,
		{
			{ 1, 1, 1, 0.5 },
			{ 1, 0.4, 1, 1 },
			{ 1, 0.2, 0.8, 1 }
		},
		1,
		0
	}

}
local evb = {}
local eve = {}

local months = {
	30, 31, 30, 31,
	31, 29, 31,
	[0] = { 2015, 9 }
}

local ela = 0
local hr, min = GetGameTime()
local sec = 0
local weekday, month, day, year = CalendarGetDate()
--local startday = 12
--local shortday = 17
--local shorthour = 15
--local vshortday = 18
--local vshorthour = 8
--local vshortmin = 45
--local eventday = 18
--local eventhour = 10
--local eventmin = 0
local main_p = 0
local short_p = 0
local vshort_p = 0
local configversion = "1.0.1"
local default = {100, 280}
local longtime = 7
local shorttime = 1
local vshorttime = 1/12
localstimer = function()
	return startday, shortday, shorthour, vshortday, vshorthour, vshortmin, eventday, eventhour, eventmin, day, hr, min, sec, main_p, short_p, vshort_p, "|||", weekday, month, day, year, hr, min,  sec
end

--startday = 12
--shortday = 17
--shorthour = 15
--vshortday = 18
--vshorthour = 8
--vshortmin = 45
--eventday = 18
--eventhour = 10
--eventmin = 0
--local normcol = {0, 0.2, 1, 0.5}
--local shortcol = {0.5, 0, 1, 1}
--local vshortcol = {1, 0.5, 0, 1}
local offset = 5/12

-- TO DELETE --
--[[
--longtime = 1
--shorttime = 1/24/60
--vshorttime = 20/24/3600
events[3] = { "TEST", 19, 10, 2015, { { 1, 0, 0, 1 }, { 0, 1, 0, 1 }, { 0, 0, 1, 1 }, {0, 0, 0, 1 } } }
events[9] = { "TEST", 20, 10, 2015, { { 0, 0, 1, 1 }, { 0, 1, 0, 1 }, { 1, 0, 0, 1 } }, 1 }
--offset = 20/24
--months[2] = 19
--months[3] = nil
]]--
-- END TO DELETE --

for k, v in pairs(events) do
	if v[6] then
		eve[v[1]] = k
		v[5][1] = events[evb[v[1]]][5][4]
		v[5][2] = events[evb[v[1]]][5][3]
		v[5][3] = events[evb[v[1]]][5][2]
		v[5][4] = events[evb[v[1]]][5][1]
		v[5][4][4] = 1
	else
		evb[v[1]] = k
	end
	if v[7] == nil then v[7] = 0 end
end

--if (year == 2015 and
--month == 10 and
--day >= startday and day <= eventday) or (hr == -1 and min == -1) then

local h3 = CreateFont("HallowTimerH3")
h3:SetFont("Fonts\\FRIZQT__.TTF", 11)
local h2 = CreateFont("HallowTimerH2")
h2:SetFont("Fonts\\FRIZQT__.TTF", 12)
local timeframe = CreateFrame("SCROLLINGMESSAGEFRAME")
timeframe.dfmt = "|H%{EVENT_ENDING}%{EVENT_NAME}|h|cffffa000%{EVENT_NAME}|r|h\n|cffffff00Time until %{EVSE}:|r\n%{DAYSD}%{HOURS}:%{MINS}:%{SECS}"
timeframe.fmt = timeframe.dfmt
timeframe.texture = timeframe:CreateTexture()
timeframe.texture:SetTexture(0, 0, 0, 0.5)
timeframe.texture:SetAllPoints(timeframe)
timeframe:SetFontObject(h3)
timeframe:SetMaxLines(128)

--timeframe:SetFont("h3", 'Fonts\\FRIZQT__.TTF', 11)
--timeframe:SetFontObject("h3", "HallowTimerH3")
--timeframe:SetFontObject("h2", "HallowTimerH2")
--timeframe:SetTextColor("h2", 1, 0.8, 0)
--timeframe:SetTextColor("h3", 1, 1, 0)
--timeframe:SetFont("a", 'Fonts\\FRIZQT__.TTF', 11)
timeframe:Clear()
timeframe:AddMessage(timeframe.fmt)
timeframe:Hide()
timeframe.sticky = 0
timeframe:SetHyperlinksEnabled(true)
--timeframe:EnableMouse(true)
--timeframe:SetHyperlinkFormat("|H%s|h%s|h")
--timeframe:EnableMouse(1)
--timeframe:EnableMouse(true)
timeframe:SetScript("OnHyperlinkClick", function(self, link, text, btn)
	--print("TARGET", link)
	local target = link:gsub("_+_", "'")
	--if btn == "LeftButton" then
		if target ~= "0" then
			glob_pos_hallowtimer.w = target:sub(2)
			glob_pos_hallowtimer.we = (tonumber(target:sub(1, 1)) == 1 and 1 or nil)
		else
			glob_pos_hallowtimer.w = nil
		end
	--end
	timeframe.sticky = 0
	timeframe:Hide()
end)
--timeframe:SetScript("OnHyperlinkClick", print)
--timeframe:SetScript("OnHyperlinkLeave", print)
--timeframe:SetScript("OnHyperlinkEnter", print)
timeframe:SetHeight(200)
timeframe:SetFading(false)
localshl =  function()
	print(timeframe:GetHyperlinksEnabled())
end

local frame = CreateFrame("FRAME", "HallowTimerFrame", UIParent)
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")
frame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" and ... == "HallowTimer" then
	frame:SetMovable(true)
	frame:EnableMouse(true)
	if glob_pos_hallowtimer == nil then
		glob_pos_hallowtimer = {x = default[1], y = default[2], c = configversion, d = default, s = frame_size_default}
	end
	if glob_pos_hallowtimer.c == "restore" then
		print("Previous configuration has been restored. You can reset to the default configuration using the '/hallowtimer reset' command")
		glob_pos_hallowtimer.x = glob_pos_hallowtimer.r[1]
		glob_pos_hallowtimer.y = glob_pos_hallowtimer.r[2]
		glob_pos_hallowtimer.s = glob_pos_hallowtimer.r.s
		glob_pos_hallowtimer.r = nil
		glob_pos_hallowtimer.c = configversion
	end
	if glob_pos_hallowtimer.c ~= configversion then
		local restore = {glob_pos_hallowtimer.x, glob_pos_hallowtimer.y, s = {glob_pos_hallowtimer.s[1], glob_pos_hallowtimer.s[2]}}
		local cause = glob_pos_hallowtimer.c == "reset" and "HallowTimer configuration reset " or "Old configuration version "
		print(cause .. " has been detected and will be overwritten. You can restore the last configuration using the '/hallowtimer restore' command")
		glob_pos_hallowtimer = {x = default[1], y = default[2], c = configversion, r = restore, d = default}
	end
	if glob_pos_hallowtimer.s == nil then
		glob_pos_hallowtimer.s = frame_size_default
	end
	self:SetUserPlaced(false)
	self:ClearAllPoints()
	self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", glob_pos_hallowtimer.x, glob_pos_hallowtimer.y)
	self:SetSize(glob_pos_hallowtimer.s[1], glob_pos_hallowtimer.s[2])
	self:SetWidth(glob_pos_hallowtimer.s[1])
	self:SetHeight(glob_pos_hallowtimer.s[2])
	if glob_pos_hallowtimer.fb ~= 1 then
		timeframe:SetPoint("BOTTOMLEFT", "HallowTimerFrame", "TOPLEFT")
		timeframe:SetPoint("BOTTOMRIGHT", "HallowTimerFrame", "TOPRIGHT")
	else
		timeframe:SetPoint("TOPLEFT", "HallowTimerFrame", "BOTTOMLEFT")
		timeframe:SetPoint("TOPRIGHT", "HallowTimerFrame", "BOTTOMRIGHT")
	end
	end
	if event == "PLAYER_LOGIN" then
		--self:Hide()
		weekday, month, day, year = CalendarGetDate()
		hr, min = GetGameTime()
		self:SetUserPlaced(false)
		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", glob_pos_hallowtimer.x, glob_pos_hallowtimer.y)
	end
end)


frame.texture = frame:CreateTexture()
frame.texture:SetTexture(0, 0.2, 1, 0.5)
frame.texture:SetAllPoints(frame)
frame.short = CreateFrame("FRAME", nil, frame)
frame.short.texture = frame.short:CreateTexture()
frame.short.texture:SetTexture(0, 1, 0.2, 1)
frame.short.texture:SetAllPoints(frame.short)
frame.short.vshort = CreateFrame("FRAME", nil, frame.short)
frame.short.vshort.texture = frame.short.vshort:CreateTexture()
frame.short.vshort.texture:SetTexture(1, 0, 0, 1)
frame.short.vshort.texture:SetAllPoints(frame.short.vshort)
frame.short.vshort.tend = CreateFrame("FRAME", nil, frame.short.vshort)
frame.short.vshort.tend.texture = frame.short.vshort.tend:CreateTexture()
frame.short.vshort.tend.texture:SetTexture(0, 0, 0, 1)
frame.short.vshort.tend.texture:SetAllPoints(frame.short.vshort.tend)
frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 100, -100)
frame.short:SetPoint("TOP", frame, "TOP")
frame.short:SetPoint("LEFT", frame, "LEFT")
frame.short:SetPoint("BOTTOM", frame, "BOTTOM")
frame.short.vshort:SetPoint("TOP", frame, "TOP")
frame.short.vshort:SetPoint("LEFT", frame, "LEFT")
frame.short.vshort:SetPoint("BOTTOM", frame, "BOTTOM")
frame.short.vshort.tend:SetPoint("TOP", frame, "TOP")
frame.short.vshort.tend:SetPoint("LEFT", frame, "LEFT")
frame.short.vshort.tend:SetPoint("BOTTOM", frame, "BOTTOM")
frame.short:SetWidth(15)
frame:Show()
frame:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" then
		self:StartMoving()
	end
	if button == "RightButton" then
		timeframe.sticky = (timeframe.sticky == 1 and 0 or 1)
	end
	if button == "MiddleButton" then
		glob_pos_hallowtimer.fb = (glob_pos_hallowtimer.fb == 1 and 0 or 1)
		timeframe:ClearAllPoints()
		if glob_pos_hallowtimer.fb ~= 1 then
			timeframe:SetPoint("BOTTOMLEFT", "HallowTimerFrame", "TOPLEFT")
			timeframe:SetPoint("BOTTOMRIGHT", "HallowTimerFrame", "TOPRIGHT")
		else
			timeframe:SetPoint("TOPLEFT", "HallowTimerFrame", "BOTTOMLEFT")
			timeframe:SetPoint("TOPRIGHT", "HallowTimerFrame", "BOTTOMRIGHT")
		end
	end
	--print("DOWN")
end)
frame:SetScript("OnHide", function(self, btn)
	timeframe:Hide()
end)
frame:SetScript("OnMouseUp", function(self, btn)
	--print("UP")
	self:StopMovingOrSizing()
	glob_pos_hallowtimer.x = self.GetLeft(self)
	glob_pos_hallowtimer.y = self.GetTop(self)
	self:SetUserPlaced(false)
end)
frame:SetScript("OnEnter", function(self, mot)
	timeframe:Show()
	--print(mot)
end)
frame:SetScript("OnLeave", function(self, mot)
	if timeframe.sticky == 0 then timeframe:Hide() end
	--print(mot)
end)
function GetTimePercentage(sd, sh, sm, ss, ed, eh, em, es, cd, ch, cm, cs)
	local starttime = ((ss / 60 + sm) / 60 + sh) / 24 + sd
	local curtime   = ((cs / 60 + cm) / 60 + ch) / 24 + cd
	local endtime   = ((es / 60 + em) / 60 + eh) / 24 + ed
	local p = (curtime - starttime) / (endtime - starttime)
	if p < 0 then p = 0 end
	if p > 1 then p = 1 end
	return p
end
		
local function clamp(v)
	if v < 0  then
		return 0
	end
	if v > 1 then
		return 1
	end
	return v
end

local function is_before(cm, ct, em, et)
	return ((ct <= et + 1/3600/24 and cm == em) or (cm < em))
end
local function is_after(cm, ct, em, et)
	return ((ct >= et and cm == em) or (cm > em))
end
local function add_days(m, t, days)
	local cm = m
	local cd = t + days
	while days >= months[cm - months[0][1]*12 - months[0][2] + 1]+1 do
		cd = cd - months[cm - months[0][1]*12 - months[0][2] + 1]
		cm = cm + 1
	end
	return cm-m, cd-t
end
		

frame:SetScript("OnUpdate", function(self, elapsed)
	--self:SetMovable(true)
	ela = ela + elapsed
	if months[year * 12 + month - months[0][1] * 12 - months[0][2] + 2] == nil then
		print("This month is not present in the addon's database.");
		self:SetScript("OnUpdate", nil)
		self:Hide()
		return
	end
	local awaiting = {}
	local nextevent =nil
	local cmd = 0
	local pmd = 0
	local nmd = 0
	cmd = months[year * 12 + month - months[0][1] * 12 - months[0][2] + 1]
	pmd = months[year * 12 + month - months[0][1] * 12 - months[0][2]]
	nmd = months[year * 12 + month - months[0][1] * 12 - months[0][2] + 2]
	local cm = year * 12 + month
	local ct = day + hr / 24 + min / 24 / 60 + sec / 24 / 3600
	local em = 0
	local et = 0
	local shm = 0
	local sht = 0
	local vsm = 0
	local vst = 0
	local sm, st
	local nextevent_a
	--self:Hide()
	for k, v in pairs(events) do
		local tm = v[4]*12 + v[3]
		local tt = v[2] + offset + v[7]/24
		--print("K", k)
		--print("CT", ct, "ET", tt, "CM", cm, "EM", tm)
		--print("TT-LT", tt - longtime)
		local ending = nil
		if v[6] then
			--print(v[1])
			--print(evb[v[1]])
			--print(events[evb[v[1]]])
			--print(events[evb[v[1]]][4])
			--print(cm, ct, events[evb[v[1]]][4]*12 + events[evb[v[1]]][3], events[evb[v[1]]][2])
			--print(cm, ct, tm, tt)
			if is_after(cm, ct, events[evb[v[1]]][4]*12 + events[evb[v[1]]][3], events[evb[v[1]]][2] + events[evb[v[1]]][7]/24) and is_before(cm, ct, tm, tt) then
				ending = 1
			end
		end
		if (ct >= tt - longtime and ct <= tt + 1/3600/24 and cm == tm) or (ct  >= tt - longtime + cmd and cm == tm - 1) or ending then
			local kk = {}
			kk.id = k
			kk.st = events[evb[v[1]]][2] + events[evb[v[1]]][7] / 24 + offset
			kk.sm = events[evb[v[1]]][4]*12 + events[evb[v[1]]][3]
			kk.et = tt
			kk.em = tm
			awaiting[#awaiting + 1] = kk
			--if (nextevent == nil or events[nextevent][6]) and (nextevent == nil or events[k][6] == nil) then
			--print(glob_pos_hallowtimer.w == events[nextevent][1] and glob_pos_hallowtimer.we == events[nextevent][6], nextevent)
			if ((nextevent == nil or is_after(awaiting[nextevent_a].em, awaiting[nextevent_a].et, tm, tt)) and (nextevent == nil or not (glob_pos_hallowtimer.w == events[nextevent][1] and glob_pos_hallowtimer.we == events[nextevent][6]))) or (glob_pos_hallowtimer.w == events[k][1] and glob_pos_hallowtimer.we == events[k][6]) then
				nextevent = k
				nextevent_a = #awaiting
				et = tt
				em = tm
				--shm = 
				self:Show()
			end
		end
	end
	if nextevent == nil then self:Hide() end
	sec = sec + elapsed
	if sec >= 60 then
		min = min + 1
		sec = sec - 60
		if min >= 60 then
			hr = hr + 1
			min = min - 60
			if hr >= 24 then
				day = day + 1
				hr = hr - 24
				if day > cmd then
					month = month + 1
					day = day - cmd
					if month >= 13 then
						year = year + 1
						month = month - 12
					end
				end
			end
		end
	end
	local ctm, stm, etm, shtm, vstm
	if nextevent ~= nil then
		ctm = ct + pmd
		--stm = st + (sm < month and 0 or pmd)
		--shtm = sht + (shm < month and 0 or (shm > month and pmd + cmd or pmd))
		--vstm = vst + (vsm < month and 0 or (vsm > month and pmd + cmd or pmd))
		etm = et + (em > cm and pmd + cmd or pmd)
		stm = etm - longtime
		if events[nextevent][7] then
			etm = etm
		end
		if events[nextevent][6] then
			stm = awaiting[nextevent_a].st + (awaiting[nextevent_a].sm > cm and pmd+cmd or (awaiting[nextevent_a].sm < cm and 0 or pmd))
		end
		--print(stm)
		shtm = etm - shorttime
		vstm = etm - vshorttime
		main_p   = clamp((ctm - stm) / (etm - stm))   --GetTimePercentage(startday, 0, 0, 0, eventday, eventhour, eventmin, 0, day, hr, min, sec)
		short_p  = clamp((ctm - shtm) / (etm - shtm)) --GetTimePercentage(shortday, shorthour, 0,        0, eventday, eventhour, eventmin, 0, day, hr, min, sec)
		vshort_p = clamp((ctm - vstm) / (etm - vstm)) --GetTimePercentage(vshortday,vshorthour,vshortmin,0, eventday, eventhour, eventmin, 0, day, hr, min, sec)
		if short_p > main_p then short_p = main_p end
		if vshort_p > short_p then vshort_p = short_p end
	--print(stm)
		frame.texture:SetTexture(unpack(events[nextevent][5][1]))
		frame.short.texture:SetTexture(unpack(events[nextevent][5][2]))
		frame.short.vshort.texture:SetTexture(unpack(events[nextevent][5][3]))
		if events[nextevent][5][4] == nil then
			frame.short.vshort.tend.texture:SetTexture(unpack(events[nextevent][5][3]))
		else
			frame.short.vshort.tend.texture:SetTexture(unpack(events[nextevent][5][4]))
		end
		for k, v in pairs(awaiting) do
			v.etm = v.et + (v.em > cm and pmd+cmd or pmd)
		end
	
		frame.short:SetWidth(main_p * glob_pos_hallowtimer.s[1])
		frame.short.vshort:SetWidth(short_p * glob_pos_hallowtimer.s[1])
		frame.short.vshort.tend:SetWidth(vshort_p * glob_pos_hallowtimer.s[1])
		frame.short:Show()
		frame.short.vshort:Show()
		frame.short.vshort.tend:Show()
		if day ~= 0 then
		if main_p == 0 then
			frame.short:Hide()
		end
		if short_p == 0 then
			frame.short.vshort:Hide()
		end
		if vshort_p == 0 then
			frame.short.vshort.tend:Hide()
		end
		if ctm > etm then
			--frame:Hide()
			--frame:SetScript("OnUpdate", nil)
		end
		if ctm < stm then
			--frame:Hide()
		end
		--if (day == eventday and hr >= eventhour and min >= eventmin + 1) or (day == eventday and hr > eventhour) or
		--(month ~= 10 or year ~= 2015) then
		--	frame:Hide()
		--	frame:SetScript("OnUpdate", nil)
		--end
		frame:SetAlpha(1)
		local text = "<html><body>"
		if timeframe.sticky == 0 then
		timeframe:SetHeight((#awaiting * 34 + (glob_pos_hallowtimer.w and 11 or 0)))
		timeframe:Clear()
		for k, v in pairs(awaiting) do
		if ctm < etm or v.id ~= nextevent then
			local sf = "%02d"
			local t = { EVENT_NAME = events[v.id][1], 
					 DAYS = math.floor((v.etm - ctm)), 
					 HOURS = string.format(sf, math.floor(((v.etm - ctm) - math.floor((v.etm - ctm))) * 24)),
					 MINS = string.format(sf, math.floor(((v.etm - ctm)* 24 - math.floor((v.etm - ctm)* 24)) * 60)),
					 SECS = string.format(sf, math.floor(((v.etm - ctm)* 24 * 60 - math.floor((v.etm - ctm)* 24 * 60)) * 60)),
					 EVSE = events[v.id][6] and "end" or "start",
					 EVENT_ID = v.id,
					 EVENT_ENDING = events[v.id][6] == 1 and 1 or 0 }
			t.DAYSD = t.DAYS == 0 and "" or string.format("%sd, ", t.DAYS)
			local textn = timeframe.fmt:gsub("%%\{([A-Z_]*)\}", function(arg)
				return t[arg]
			end)
			timeframe:AddMessage(textn)
			timeframe:SetHyperlinksEnabled(true)
			text = text .. textn
			--timeframe:Hide()
			--timeframe:Show()
		end
		end
		if glob_pos_hallowtimer.w then
			timeframe:AddMessage("|H0|h|cffff0000Reset|r|h")
		end
			if timeframe:IsVisible() then
			timeframe:Hide()
			timeframe:Show()
			end
		end
		text = text .. "</body></html>"
		--timeframe:SetHyperlinksEnabled(false)
	--	timeframe:AddMessage(text)
		--timeframe:SetHyperlinksEnabled(true)
		if ctm >= etm and ctm <= etm + 1/24/3600 then
			--if sec > 1 then
			--	frame:Hide()
			--end
			local alpha = 1
			--local white = 0
			--if sec < 0.4 then
			--	white = (sec / 0.4)
			--elseif sec < 1 then
			--	alpha = 1 - (1 - (sec - 0.4)) / 0.6
			--end
			alpha = 1 - sec
			--frame.short.vshort.tend.texture:SetTexture(white, white, white, alpha)
			--frame.short.vshort.texture:SetTexture(0, 0, 0, 0)
			--frame.short.texture:SetTexture(0, 0, 0, 0)
			--frame.texture:SetTexture(0, 0, 0, 0)
			frame:SetAlpha(alpha)
		end
		end
		local tempmin
		_, tempmin = GetGameTime()
		if (tempmin) > (min) and (tempmin - min <= 2) then
			sec = 0
			min = tempmin
		end
	end
	if ela > 1 then
		ela = 0
		--print ("NEVENT", nextevent, "CT", ctm, "ST", stm, "ET", etm, "MAIN", main_p, "SHORT", short_p, "VSH", vshort_p)
	end
end)



SLASH_HALTIM1 = "/hallowtimer"
SlashCmdList.HALTIM = function(arg, ...)
	if arg == "reset" then
		glob_pos_hallowtimer.c = "reset"
		ReloadUI()
	else
		if arg == "restore" then
			glob_pos_hallowtimer.c = "restore"
			ReloadUI()
		else
			print("Usage: /hallowtimer reset - Restores the default configuration")
			print("Usage: /hallowtimer restore - Restores the configuration from before reset")
			print("Usage: Right-click the bar and then click the event name or reset button to make the bar indicate time until the selected or the nearest event")
		end
	end
end







--end